<!-- 系统配置 - 权限配置 -->
<template>
  <div class="page">
    <topBar
      v-if="topList.length > 0"
      :top-list="topList"
      :moren="moren"
    />
    <div class="main">
      <div class="maintop">
        <span class="colors" />
        <div style="margin: 0 0 0 15px;font-weight: bold">{{ '短信模板' }}</div>
      </div>
      <div class="maintable">
        <el-form ref="forms" :rules="rules" :model="table" label-width="80px">
          <el-form-item :label="'短信编号'" prop="templateCode">
            <el-input
              v-model="table.templateCode"
              :disabled="disableds"
              class="heights"
              clearable
              :placeholder="'请输入短信编号'"
            />
          </el-form-item>
          <el-form-item :label="'模板名称'" prop="templateName">
            <el-input
              v-model="table.templateName"
              :disabled="disableds"
              class="heights"
              clearable
              :placeholder="'请输入模板名称'"
            />
          </el-form-item>
          <el-form-item label="短信内容" prop="templateContent">
            <el-input
              v-model="table.templateContent"
              :disabled="disableds"
              type="textarea"
              :rows="5"
              class="height"
              clearable
              :placeholder="'请输入短信内容'"
            />
          </el-form-item>
        </el-form>
      </div>
    </div>

    <el-dialog
      :title="'添加'"
      :visible.sync="ruleShow"
      width="50%"
      center
      :close-on-click-modal="false"
      :before-close="handleClose"
    >
      <el-form ref="forms" :rules="rules" :model="table" label-width="80px">
        <el-form-item :label="'角色姓名'" prop="roleName">
          <el-input
            v-model="table.roleName"
            clearable
            :placeholder="'请输入短信编号'"
          />
        </el-form-item>
        <el-form-item :label="'显示排序'" prop="roleSort">
          <el-input
            v-model="table.roleSort"
            type="number"
            clearable
            :placeholder="'请输入模板名称'"
          />
        </el-form-item>
        <el-form-item :label="'权限字符'" prop="roleKey">
          <el-input
            v-model="table.roleKey"
            clearable
            :placeholder="'请输入短信内容'"
          />
        </el-form-item>
        <el-form-item :label="'状态'" prop="status">
          <el-checkbox-group v-model="table.status" @change="statusChange">
            <el-checkbox
              v-for="(item, index) in statusList"
              :key="index"
              :label="item.name"
              name="type"
            />
          </el-checkbox-group>
        </el-form-item>
        <div style="padding-top: 100px;display: flex;justify-content: center">
          <el-button type="text" size="small" class="button-style" @click="handleClose"> {{ '取消' }}</el-button>
          <el-button v-preventReClick="3000" type="text" size="small" class="button-style" style="margin-left: 40px;background-color: #48B2FD;" @click="submitBtn()">
            {{ '确认' }}
          </el-button>
        </div>
      </el-form>
    </el-dialog>
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="research"
    />
    <div class="footer">
      <el-button
        size="small"
        class="thebtn2"
        @click="$router.push('/configManage/smsRecord/smsTemplate');"
      > {{ '取消' }}</el-button>
      <el-button
        size="small"
        class="thebtn1"
        :disabled="disableds"
        @click="submit"
      > {{ '确认' }}</el-button>
    </div>
  </div>
</template>

<script>
import topBar from '@/components/topBar'
import { findAllArea } from '@/api/product'
import { getbdmenuList, getPubenumsList } from '@/api/system'
import { getgradeRanglist, getAwardsListChiose } from '@/api/level'
const { getQueryString } = require('@/utils/index')
import * as api from '@/api/sms'
import { Message } from 'element-ui'
import { deleteAgreement } from '@/api/configManage'
export default {
  name: 'Qxpz',
  components: {
    topBar
  },
  data() {
    return {
      disableds: false,
      forms: '',
      rules: {
        templateCode: [
          { required: true, message: '请输入短信编号', trigger: 'blur' }
        ],
        templateName: [
          { required: true, message: '请输入模板名称', trigger: 'blur' }
        ],
        templateContent: [
          { required: true, message: '请输入短信内容', trigger: 'blur' }
        ]
      },
      table: { 'templateCode': '', 'templateName': '', 'templateContent': '' },
      ruleShow: false,
      moren: 'smsTemplate',
      topList: [
        {
          name: '短信记录',
          path: 'smsRecordList'
        },
        {
          name: '短信模板',
          path: 'smsTemplate'
        },
        {
          name: '新增短信',
          path: 'addSms'
        }
      ],
      defaultParams: {
        label: 'name',
        value: 'pkId',
        children: 'children'
      },
      multipleSelection: [],
      queryParams: {
        changeAreaList: [],
        recProvince: '',
        recCity: '',
        recCounty: '',
        pageNum: 1,
        pageSize: 50,
        userName: '', // 角色姓名
        roleString: '', // 权限字符
        status: '' // 状态
      },
      gradeRangList: [],
      awardsList: [],
      statusList: [{ 'name': '正常', 'id': '0' }, { 'name': '停用', 'id': '1' }],
      menuOptions: [],
      tableData: [],
      total: 0,
      types: 1,
      pkId: '',
      allAreaList: []
    }
  },
  created() {
    // this.research()
    // this.getData()
    // this.findAllArea()
    const geturl = window.location.href
    const getqyinfo = geturl.split('?')[1]
    const getqys = new URLSearchParams('?' + getqyinfo)
    const state = getqys.get('state')
    const pkId = getqys.get('pkId')
    if (state == 2) {
      this.disableds = true
    }
    if (pkId) {
      console.error("111")
      this.pkId = pkId
      this.types = 2
      this.getSmsDetail(pkId)
    }
  },
  methods: {
    // 获取模板详情
    getSmsDetail(id) {
      api.detail(id).then((res) => {
        if (res.code == 200) {
          this.pkId = res.data.pkId
          this.table = {
            templateName: res.data.templateName,
            templateCode: res.data.templateCode,
            templateContent: res.data.templateContent
          }
        }
      })
    },
    handleChange1(res) {
      this.queryParams.recProvince = res[0]
      this.queryParams.recCity = res[1]
      this.queryParams.recCounty = res[2]
    },
    // 查询全部地区
    findAllArea() {
      findAllArea().then((res) => {
        this.allAreaList = res.data
        this.allAreaList.forEach((item) => {
          item.children.forEach((ctm, cdx) => {
            ctm.isShow = true
          })
          item.isShow = true
        })
        this.allTsAreaList = JSON.parse(JSON.stringify(this.allAreaList))
        this.allTsAreaList.forEach((item, index) => {
          this.$set(this.allTsAreaList[index], 'changeTsCldList', [])
        })
        this.allNoAreaList = JSON.parse(JSON.stringify(this.allAreaList))
        this.allNoAreaList.forEach((item, index) => {
          this.$set(this.allNoAreaList[index], 'changeNoCldList', [])
        })
      })
    },
    getData() {
      // 真实奖衔下拉选
      getAwardsListChiose().then((res) => {
        this.awardsList = res.rows
      })
      // 注册等级下拉
      getgradeRanglist().then((res) => {
        this.gradeRangList = res.data
      })
    },
    addRules() {
      this.types = 1
      this.ruleShow = true
    },
    submit() {
      this.ruleSubmit()
    },
    submitBtn() {
      // 添加角色
    },
    updateShow(item) {
      this.types = 2
      // 更新角色信息
      this.formId = item.roleId
      api.roleDetails(item.roleId).then((res) => {
        if (res.code === 200) {
          this.ruleShow = true
          this.table = { 'roleName': res.data.roleName, 'roleSort': res.data.roleSort,
            'roleKey': res.data.roleKey, 'status': res.data.status === 0 ? ['正常'] : ['停用'] }
        } else {
          Message({
            message: res.msg,
            type: 'error'
          })
        }
      })
    },
    delRole(item) {
      // 删除角色信息
      this.$confirm('确认要删除该角色吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        api.delRole(item.roleId).then((res) => {
          if (res.code === 200) {
            Message({
              message: '删除成功',
              type: 'success'
            })
            this.research()
          } else {
            Message({
              message: res.msg,
              type: 'error'
            })
          }
        })
      })
    },
    ruleSubmit() {
      const datas = this.table
      this.$refs['forms'].validate(valid => {
        if (!valid) {
          return false
        } else {
          if (this.types === 1) {
            api.save(datas).then((res) => {
              if (res.code === 200) {
                Message({
                  message: res.msg,
                  type: 'success'
                })
                this.$router.push('/configManage/smsRecord/smsTemplate')
              } else {
                Message({
                  message: res.msg,
                  type: 'error'
                })
              }
            })
          }
          if (this.types === 2) {
            datas.pkId = this.pkId
            api.save(datas).then((res) => {
              if (res.code === 200) {
                Message({
                  message: res.msg,
                  type: 'success'
                })
                this.$router.push('/configManage/smsRecord/smsTemplate')
              } else {
                Message({
                  message: res.msg,
                  type: 'error'
                })
              }
            })
          }
        }
      })
    },
    statusChange(value) {
      if (this.table.status.length > 1) {
        this.table.status.splice(0, 1)
      }
    },
    handleClose() {
      this.ruleShow = false
      this.table = { 'ruleName': '', 'sort': '', 'ruleStr': '', 'status': ['正常'] }
    },
    changeBox(row) {
      console.error(row)
    },
    addFrom() {
    },
    addRule() {
    },
    changeTime(value) {
      // this.queryParams.creationTime = value[0]
      // this.queryParams.endCreationTime = value[1]
    },
    handleChangeMunu(value) {
      console.log('🌈', value[value.length - 1])
      this.queryParams.menuId = value[value.length - 1]
    },
    // 菜单下拉选
    getPubenumsList() {
      getPubenumsList().then((res) => {
        this.menuOptions = res.data
      })
    },
    // 等级范围选择
    getgradeRanglist() {
      getgradeRanglist().then((res) => {
        this.gradeRangList = res.data
      })
    },
    // 奖衔下拉列表
    getAwardsListChiose() {
      getAwardsListChiose().then((res) => {
        this.awardsList = res.rows
      })
    },
    research() {
      // // 日期传入改为起止两个字段
      // if ("" != this.queryParams.creationTime) {
      //   this.queryParams.creationTimeStart = this.queryParams.creationTime[0];
      //   this.queryParams.creationTimeEnd = this.queryParams.creationTime[1];
      // }

      // creationTime: '', // 开始时间
      //   modifiedTime: '' // 结束时间
      api.orderSelect(this.queryParams).then((res) => {
        // res.rows.forEach((element) => {
        //   element.alist = []
        //   element.blist = []
        //   element.clist = []
        //   element.themenus = ''
        //   element.theaward = ''
        //   element.thegrade = ''
        //   element.menuList.forEach((item) => {
        //     element.alist.push(item.menuVal)
        //     element.themenus = element.alist.join('/')
        //   })
        //   element.awardList.forEach((item) => {
        //     element.blist.push(item.awardVal)
        //     element.theaward = element.blist.join('/')
        //   })
        //   element.gradeList.forEach((item) => {
        //     element.clist.push(item.gradeVal)
        //     element.thegrade = element.clist.join('/')
        //   })
        // })

        this.tableData = res.rows
        this.total = res.total
      })
    },
    reChongzhi() {
      this.queryParams = {
        pageNum: 1,
        pageSize: 50,
        userName: '', // 角色姓名
        roleString: '', // 权限字符
        status: '', // 状态
        startDate: '', // 开始时间
        endDate: [] // 结束时间
      }
      this.research()
    },

    handleSelectionChange(val) {
      this.multipleSelection = val
    },
    objectSpanMethod({ row, column, rowIndex, columnIndex }) {
      // if (columnIndex === 0) {
      //   if (rowIndex % 2 === 0) {
      //     return {
      //       rowspan: 2,
      //       colspan: 1,
      //     };
      //   } else {
      //     return {
      //       rowspan: 0,
      //       colspan: 0,
      //     };
      //   }
      // }
    },
    tableRowClassName({ row, rowIndex }) {
      if (rowIndex % 2 == 1) {
        return 'warning-row'
      } else if (rowIndex % 2 == 0) {
        return 'success-row'
      }
      return ''
    }
  }
}
</script>
<style lang="scss" scoped>
::v-deep .heights .el-input__inner{
  height: 44px;
  line-height: 44px;
}
.maintable{
  padding:0 20px;
}
.colors{
  width: 5px;
  height: 19px;
  background: #4391FD;
  border-radius: 0px 0px 0px 0px;
  opacity: 1;
}
::v-deep .lables .el-form-item__content{
  margin-left: 20px!important;
}
.footer {
  height: 68px;
  background: #ffffff;
  box-shadow: 0px -3px 20px 0px rgba(204, 204, 204, 0.5);
  // margin: 0 20px;
  display: flex;
  justify-content: center;
  align-items: center;
  .thebtn1 {
    background: #3181e5;
    color: #ffffff;
    padding: 9px 45px;
  }
  .thebtn2 {
    background: #cccccc;
    color: #ffffff;
    padding: 9px 45px;
  }
}

.button-style{
  width: 209px;
  height: 48px;
  background: #CCCCCC;
  border-radius: 5px 5px 5px 5px;
  opacity: 1;
  line-height: 48px;
  padding: 0!important;
  color: #fff;
  font-size: 18px;
}
::v-deep .el-dialog__title{
  font-weight: bold;
}
::v-deep .el-dialog__header{
  border-bottom: 1px solid rgba(0,0,0,0.1);
}
.button-s{
  padding: 0 2px!important;
}
::v-deep .el-button{
  padding: 10px 20px;
}
::v-deep .el-date-editor .el-range__close-icon{
  margin-top: -10px;
}
::v-deep .el-date-editor .el-range-separator{
  margin-top: -10px;
}
::v-deep .el-date-editor .el-range__icon{
  margin-top: -10px;
}
::v-deep .el-input__inner{
  //height:28px;
  //line-height: 28px;
}
::v-deep .el-form-item__label{
  color: #333;
  font-weight: inherit;
}
::v-deep .el-row {
  margin-top: 20px;
}
::v-deep .el-table .warning-row {
  background: #f9f9f9;
}

::v-deep .el-table .success-row {
  background: #ffffff;
}
::v-deep .el-table thead {
  color: #000000;
}
.openClose {
  margin-top: 10px;
  margin-right: 10px;
  color: #666666;
  text-align: center;
}
.page {
  padding: 20px;
  background: #f9f9f9;
  font-size: 14px;
  .thetopbox {
    background: #ffffff;
    border-radius: 8px;
    .searchbox {
      display: flex;
      align-items: center;
      .searchtitle {
        margin-right: 10px;
      }
      .searchbtn {
        background: #08143f;
        color: #ffffff;
      }
    }
  }
  .main {
    margin-top: 20px;
    background: #ffffff;
    border-radius: 8px;
    box-shadow: 0px 2px 20px 0px rgba(238, 238, 238, 0.5);

    .maintop {
      display: flex;
      padding: 20px 10px 10px 0;
      //justify-content: space-between;
      //align-items: center;
      border-bottom: 1px solid rgba(0,0,0,0.1);
      margin-bottom: 30px;
      .mainbtn {
        .thebtn1 {
          color: #ffffff;
          background: rgba(67, 145, 253, 1);
        }
      }
    }
  }
}
</style>
